
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Purchase_ordersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const purchase_orders = await db.purchase_orders.create(
            {
                id: data.id || undefined,
        
        po_number: data.po_number
        ||
        null
            ,
            
        order_date: data.order_date
        ||
        null
            ,
            
        expected_delivery_date: data.expected_delivery_date
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        subtotal: data.subtotal
        ||
        null
            ,
            
        tax_total: data.tax_total
        ||
        null
            ,
            
        discount_total: data.discount_total
        ||
        null
            ,
            
        grand_total: data.grand_total
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await purchase_orders.setCompany( data.company || null, {
            transaction,
        });
        
        await purchase_orders.setVendor( data.vendor || null, {
            transaction,
        });
        
        await purchase_orders.setBuyer( data.buyer || null, {
            transaction,
        });
        
        await purchase_orders.setSource_requisition( data.source_requisition || null, {
            transaction,
        });
        
        await purchase_orders.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.purchase_orders.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: purchase_orders.id,
            },
            data.attachments,
            options,
        );
        

        return purchase_orders;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const purchase_ordersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                po_number: item.po_number
            ||
            null
            ,
            
                order_date: item.order_date
            ||
            null
            ,
            
                expected_delivery_date: item.expected_delivery_date
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                subtotal: item.subtotal
            ||
            null
            ,
            
                tax_total: item.tax_total
            ||
            null
            ,
            
                discount_total: item.discount_total
            ||
            null
            ,
            
                grand_total: item.grand_total
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const purchase_orders = await db.purchase_orders.bulkCreate(purchase_ordersData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < purchase_orders.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.purchase_orders.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: purchase_orders[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return purchase_orders;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const purchase_orders = await db.purchase_orders.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.po_number !== undefined) updatePayload.po_number = data.po_number;
        
        
        if (data.order_date !== undefined) updatePayload.order_date = data.order_date;
        
        
        if (data.expected_delivery_date !== undefined) updatePayload.expected_delivery_date = data.expected_delivery_date;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.subtotal !== undefined) updatePayload.subtotal = data.subtotal;
        
        
        if (data.tax_total !== undefined) updatePayload.tax_total = data.tax_total;
        
        
        if (data.discount_total !== undefined) updatePayload.discount_total = data.discount_total;
        
        
        if (data.grand_total !== undefined) updatePayload.grand_total = data.grand_total;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await purchase_orders.update(updatePayload, {transaction});

        
        
        if (data.company !== undefined) {
            await purchase_orders.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.vendor !== undefined) {
            await purchase_orders.setVendor(
              
              data.vendor,
              
              { transaction }
            );
        }
        
        if (data.buyer !== undefined) {
            await purchase_orders.setBuyer(
              
              data.buyer,
              
              { transaction }
            );
        }
        
        if (data.source_requisition !== undefined) {
            await purchase_orders.setSource_requisition(
              
              data.source_requisition,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await purchase_orders.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.purchase_orders.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: purchase_orders.id,
            },
            data.attachments,
            options,
        );
        

        return purchase_orders;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const purchase_orders = await db.purchase_orders.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of purchase_orders) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of purchase_orders) {
                await record.destroy({transaction});
            }
        });


        return purchase_orders;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const purchase_orders = await db.purchase_orders.findByPk(id, options);

        await purchase_orders.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await purchase_orders.destroy({
            transaction
        });

        return purchase_orders;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const purchase_orders = await db.purchase_orders.findOne(
            { where },
            { transaction },
        );

        if (!purchase_orders) {
            return purchase_orders;
        }

        const output = purchase_orders.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.purchase_order_lines_purchase_order = await purchase_orders.getPurchase_order_lines_purchase_order({
            transaction
        });
        
        
        output.goods_receipts_purchase_order = await purchase_orders.getGoods_receipts_purchase_order({
            transaction
        });
        
        
        
        output.vendor_invoices_purchase_order = await purchase_orders.getVendor_invoices_purchase_order({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.company = await purchase_orders.getCompany({
            transaction
        });
        
        
        output.vendor = await purchase_orders.getVendor({
            transaction
        });
        
        
        output.buyer = await purchase_orders.getBuyer({
            transaction
        });
        
        
        output.source_requisition = await purchase_orders.getSource_requisition({
            transaction
        });
        
        
        output.attachments = await purchase_orders.getAttachments({
            transaction
        });
        
        
        output.organizations = await purchase_orders.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.companies,
        as: 'company',
        
        where: filter.company ? {
          [Op.or]: [
            { id: { [Op.in]: filter.company.split('|').map(term => Utils.uuid(term)) } },
            {
              company_name: {
                [Op.or]: filter.company.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.vendors,
        as: 'vendor',
        
        where: filter.vendor ? {
          [Op.or]: [
            { id: { [Op.in]: filter.vendor.split('|').map(term => Utils.uuid(term)) } },
            {
              vendor_name: {
                [Op.or]: filter.vendor.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'buyer',
        
        where: filter.buyer ? {
          [Op.or]: [
            { id: { [Op.in]: filter.buyer.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.buyer.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.purchase_requisitions,
        as: 'source_requisition',
        
        where: filter.source_requisition ? {
          [Op.or]: [
            { id: { [Op.in]: filter.source_requisition.split('|').map(term => Utils.uuid(term)) } },
            {
              requisition_number: {
                [Op.or]: filter.source_requisition.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.po_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'purchase_orders',
                        'po_number',
                        filter.po_number,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'purchase_orders',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.order_dateRange) {
                const [start, end] = filter.order_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    order_date: {
                    ...where.order_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    order_date: {
                    ...where.order_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.expected_delivery_dateRange) {
                const [start, end] = filter.expected_delivery_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expected_delivery_date: {
                    ...where.expected_delivery_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expected_delivery_date: {
                    ...where.expected_delivery_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.subtotalRange) {
                const [start, end] = filter.subtotalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    subtotal: {
                    ...where.subtotal,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    subtotal: {
                    ...where.subtotal,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.tax_totalRange) {
                const [start, end] = filter.tax_totalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    tax_total: {
                    ...where.tax_total,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    tax_total: {
                    ...where.tax_total,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.discount_totalRange) {
                const [start, end] = filter.discount_totalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    discount_total: {
                    ...where.discount_total,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    discount_total: {
                    ...where.discount_total,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.grand_totalRange) {
                const [start, end] = filter.grand_totalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    grand_total: {
                    ...where.grand_total,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    grand_total: {
                    ...where.grand_total,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            
            if (filter.currency) {
                where = {
                    ...where,
                currency: filter.currency,
            };
            }
            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.purchase_orders.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'purchase_orders',
                        'po_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.purchase_orders.findAll({
            attributes: [ 'id', 'po_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['po_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.po_number,
        }));
    }

    
};

